#include <OB/CORBA.h>
#include "Hello.h"

#include <fstream.h>

int run(CORBA::ORB_ptr, char* text);

int main(int argc, char* argv[]) {
	if (argc != 2) {
		(void) fprintf(stderr, "Usage: %s \"Text that you want Simon to say\n\"",argv[0]);
		return EXIT_FAILURE;
	}
	int status = EXIT_SUCCESS;
	CORBA::ORB_var orb;

	try {
		orb = CORBA::ORB_init(argc, argv);
		status = run(orb, argv[1]);
	}catch(const CORBA::Exception&){
		status = EXIT_FAILURE; 
	}

	if(!CORBA::is_nil(orb)) {
		try {
			orb -> destroy();
		} catch (const CORBA::Exception&){
			status = EXIT_FAILURE;
		}
	}
	return status;
}

int run(CORBA::ORB_ptr orb, char* text) {
	
	const char* refFile = "Server.ref";
	ifstream in(refFile);
	char s[2048];
	in >> s;
	CORBA::Object_var obj = orb -> string_to_object(s);

	Hello_var hello = Hello::_narrow(obj);

	hello -> say_hello(text);

	return 0;
}
